package id.co.sangkuriang.inovasi.daerah.master.config

import id.co.sangkuriang.inovasi.daerah.master.constant.TOKEN_FILTER_PATTERNS
import id.co.sangkuriang.inovasi.daerah.master.interceptor.TokenInterceptor
import org.springframework.boot.web.servlet.FilterRegistrationBean
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.web.servlet.config.annotation.CorsRegistry
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer


@Configuration
class SpringWebConfig : WebMvcConfigurer {

    override fun addCorsMappings(registry: CorsRegistry) {
        registry.addMapping("/**")
            .allowedMethods("HEAD", "GET", "POST", "PUT", "DELETE", "PATCH", "OPTIONS", "PUT", "TRACE")
            .allowedOrigins("*")
            .allowedHeaders("*")
            .maxAge(60000)
    }

    @Bean
    fun tokenFilter(): FilterRegistrationBean<TokenInterceptor>? {
        val registrationBean: FilterRegistrationBean<TokenInterceptor> =
            FilterRegistrationBean<TokenInterceptor>()
        TOKEN_FILTER_PATTERNS.forEach {
            registrationBean.addUrlPatterns("/$it/*")
        }
        registrationBean.filter = TokenInterceptor()
        registrationBean.order = 1
        return registrationBean
    }
}
